﻿using System;
using System.Collections.Generic;
using TSLab.Script;
using TSLab.Script.Handlers;
using TSLab.Script.Realtime;

namespace SomeIndicators
{

    public class CurrentBid : IBar2DoubleHandler
    {
        public IList<double> Execute(ISecurity source)
        {
            var rt = source as ISecurityRt;
            var v = rt == null ? 0.0 : rt.FinInfo.Bid.HasValue ? rt.FinInfo.Bid.Value : 0.0;
            var res = new double[source.Bars.Count];
            for(int i = 0; i < res.Length;i++)
            {
                res[i] = v;
            }
            return res;
        }
    }

    public class CurrentAsk : IBar2DoubleHandler
    {
        public IList<double> Execute(ISecurity source)
        {
            var rt = source as ISecurityRt;
            var v = rt == null ? 0.0 : rt.FinInfo.Ask.HasValue ? rt.FinInfo.Ask.Value : 0.0;
            var res = new double[source.Bars.Count];
            for (int i = 0; i < res.Length; i++)
            {
                res[i] = v;
            }
            return res;
        }
    }

    public class CurrentBuyCount : IBar2DoubleHandler
    {
        public IList<double> Execute(ISecurity source)
        {
            var rt = source as ISecurityRt;
            var v = rt == null ? 0.0 : rt.FinInfo.BuyCount.HasValue ? rt.FinInfo.BuyCount.Value : 0.0;
            var res = new double[source.Bars.Count];
            for (int i = 0; i < res.Length; i++)
            {
                res[i] = v;
            }
            return res;
        }
    }

    public class CurrentSellCount : IBar2DoubleHandler
    {
        public IList<double> Execute(ISecurity source)
        {
            var rt = source as ISecurityRt;
            var v = rt == null ? 0.0 : rt.FinInfo.SellCount.HasValue ? rt.FinInfo.SellCount.Value : 0.0;
            var res = new double[source.Bars.Count];
            for (int i = 0; i < res.Length; i++)
            {
                res[i] = v;
            }
            return res;
        }
    }
}
